const { settings } = require('cluster')
const fs = require('fs')

class Config {

    constructor(options = {
        path: './settings.json'
    }) {
        this.path = options.path
        this.json = {}

        console.log('path', this.path)
    }

    open() {
        return new Promise((resolve, reject) => {
            fs.stat(this.path, (err, stats) => {
                if (! err) {
                    this.json = JSON.parse(fs.readFileSync(this.path, 'utf8'))

                    console.log('json', this.json)
                    resolve(true)
                } else {
                    console.log(err)
                    resolve(true)
                }
            })
        })
    }

    set(key, value) {
        this.json[key] = value
    }

    get(key) {
        return this.json[key]
    }

    removeKey(key) {
        delete this.json[key]
    }

    save() {
        return new Promise((resolve, reject) => {
            let s = JSON.stringify(this.json, null, 4)
            fs.writeFileSync(this.path, s)
            resolve(true)
        })
    }
}

module.exports = Config